precision highp float;
//using medium precision float operations instead of  highp (works faster on mobile devices)

uniform sampler2D tex;
varying vec2 fsTexCoords;
uniform float progress;
 
uniform  vec4 strength;
uniform  float Plx1;
uniform  float Plx2;
uniform  float deltaUV;
uniform float maxU;
uniform float maxV;
 
 void main()
 {
     vec2 posDistortion=vec2(fsTexCoords.x*strength.x+fsTexCoords.y*strength.y,
     						 fsTexCoords.x*strength.z+fsTexCoords.y*strength.w);
     
     vec2 angles=vec2(posDistortion.x +  Plx1, posDistortion.y +  Plx2);
     
     vec2 distortion=deltaUV * vec2(cos(angles.x),sin(angles.y));
     
     vec2 tcu=fsTexCoords + distortion;
     
     if(tcu.x > maxU){
         tcu.x = maxU;
     }else if(tcu.y > maxV){
         tcu.y = maxV;
     }
     
	 gl_FragColor = texture2D(tex, tcu);
     
 }