precision highp float;
 
varying vec2 fsTexCoords;
 
uniform sampler2D tex;
 
uniform vec2 center;
uniform float radius;
uniform float scale;
uniform float maxU;
uniform float maxV;

void main()
{
     vec2 textureCoordinateToUse = fsTexCoords;
     float dist = distance(center, textureCoordinateToUse);
     textureCoordinateToUse -= center;
     if (dist < radius)
     {
         float percentX = 1.0 + (radius - dist) * scale;
         float percentY = 1.0 + (radius - dist) * scale;
         
         textureCoordinateToUse.x = textureCoordinateToUse.x * percentX;
         textureCoordinateToUse.y = textureCoordinateToUse.y * percentY;
     }
     textureCoordinateToUse += center;
     
     if(textureCoordinateToUse.x > maxU){
         textureCoordinateToUse.x = maxU;
     }else if(textureCoordinateToUse.y > maxV){
         textureCoordinateToUse.y = maxV;
     }
        
     gl_FragColor = texture2D(tex, textureCoordinateToUse);
     
}