precision mediump float;
//using medium precision float operations instead of  highp (works faster on mobile devices)

uniform sampler2D tex;
varying vec2 fsTexCoords;
uniform float progress;
 
uniform  vec2 center;
uniform  float radius;
uniform  float angle;

uniform float maxU;
uniform float maxV;
 
 void main()
 {
     vec2 textureCoordinateToUse = fsTexCoords;
     float dist = distance(center, fsTexCoords);
     textureCoordinateToUse -= center;
     if (dist < radius)
     {
         float percent = (radius - dist) / radius;
         float theta = percent * percent * angle * 8.0;
         float s = sin(theta);
         float c = cos(theta);
         textureCoordinateToUse = vec2(dot(textureCoordinateToUse, vec2(c, -s)), dot(textureCoordinateToUse, vec2(s, c)));
     }
     textureCoordinateToUse += center;
    
    if(textureCoordinateToUse.x>maxU){
    	textureCoordinateToUse.x=maxU;
    }else if(textureCoordinateToUse.y>maxV){
    	textureCoordinateToUse.y=maxV;
    }
    
     gl_FragColor = texture2D(tex, textureCoordinateToUse );
     
 }